/**
 * 实验运行中信息实体类
 */
export interface ExperimentRunningInfoModel {
  /** 试验状态 */
  status: string;

  /** 试验状态中文 */
  status_text: string;

  /** 电池表面实时温度1 */
  temp1: number;

  /** 烘箱温度 */
  temp2: number;

  /** 电池表面实时温度2 */
  temp3: number;

  /** 电池电压 */
  voltage: number;

  /** 初始电压 */
  start_voltage: number;


  /** 挤压结束条件 */
  result: string;

  /** 实验总时间 */
  all_time: number;

  /** 静置时间 */
  standtime: string;


  // 电流
  electric: number
}
