/**
 * 添加实验实体类
 */
export interface InsertExperimentModel {
  /** 试验id */
  experiment_id: string;

  /** 用户id */
  user_id: string;

  /** 用户昵称 */
  user_name: string;

  /** 样品名称 */
  name: string;

  /** 样品编号 */
  specimen_code: string;

  /** 电池高度 */
  specimen_height: number | string;

  /** 电池型号 */
  specimen_model: string;

  /** 电池厂家 */
  specimen_manufacturer: string;

  /** 压力值 */
  pressure_value: number | string;

  /** 试验速度 */
  test_speed: number | string;

  /** 放置时间 */
  placement_time: number | string;

  /** 试验温度 */
  test_temp: number | string;

  /** 试验类型: 1 挤压 2 针刺 */
  test_type: number | string;

  /** 是否新增样片 */
  isAdd?: string;
}
