/**
 * 用户实体类
 */
export interface UserModel {
  created_time?: string;
  is_enabled?: number | string;

  /** 姓名，增加用户时传递的name */
  real_name: string;

  remark?: string;

  role_id: string;

  update_time?: string;

  user_id: string;

  /** 用户名(登录名)，增加用户时传递的username */
  user_name: string;

  user_phone?: string;

  /** 密码，增加用户时传递的password */
  user_pwd: string;
  user_pwd2?: string | null;

  /** 姓名，增加用户时传递的sex */
  user_sex: number | string;
}
